Index: LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5141)
@@ -1,3 +1,2 @@
-
 ! $Id$
 
@@ -11,54 +10,53 @@
   USE lmdz_conema3
   USE lmdz_cvflag
+  USE lmdz_cv3param
 
   IMPLICIT NONE
 
-!------------------------------------------------------------
-!Set parameters for convectL for iflag_con = 3
-!------------------------------------------------------------
-
-
-!***  PBCRIT IS THE CRITICAL CLOUD DEPTH (MB) BENEATH WHICH THE ***
-!***      PRECIPITATION EFFICIENCY IS ASSUMED TO BE ZERO     ***
-!***  PTCRIT IS THE CLOUD DEPTH (MB) ABOVE WHICH THE PRECIP. ***
-!***            EFFICIENCY IS ASSUMED TO BE UNITY            ***
-!***  SIGD IS THE FRACTIONAL AREA COVERED BY UNSATURATED DNDRAFT  ***
-!***  SPFAC IS THE FRACTION OF PRECIPITATION FALLING OUTSIDE ***
-!***                        OF CLOUD                         ***
-
-![TAU: CHARACTERISTIC TIMESCALE USED TO COMPUTE ALPHA & BETA]
-!***    ALPHA AND BETA ARE PARAMETERS THAT CONTROL THE RATE OF ***
-!***                 APPROACH TO QUASI-EQUILIBRIUM           ***
-!***    (THEIR STANDARD VALUES ARE 1.0 AND 0.96, RESPECTIVELY) ***
-!***           (BETA MUST BE LESS THAN OR EQUAL TO 1)        ***
-
-!***    DTCRIT IS THE CRITICAL BUOYANCY (K) USED TO ADJUST THE ***
-!***                 APPROACH TO QUASI-EQUILIBRIUM           ***
-!***                     IT MUST BE LESS THAN 0              ***
-
-  include "cv3param.h"
-
-  INTEGER, INTENT(IN)              :: nd
-  INTEGER, INTENT(IN)              :: k_upper
-  REAL, INTENT(IN)                 :: delt ! timestep (seconds)
-
-! Local variables
-  CHARACTER (LEN=20) :: modname = 'cv3_param'
-  CHARACTER (LEN=80) :: abort_message
+  !------------------------------------------------------------
+  !Set parameters for convectL for iflag_con = 3
+  !------------------------------------------------------------
+
+
+  !***  PBCRIT IS THE CRITICAL CLOUD DEPTH (MB) BENEATH WHICH THE ***
+  !***      PRECIPITATION EFFICIENCY IS ASSUMED TO BE ZERO     ***
+  !***  PTCRIT IS THE CLOUD DEPTH (MB) ABOVE WHICH THE PRECIP. ***
+  !***            EFFICIENCY IS ASSUMED TO BE UNITY            ***
+  !***  SIGD IS THE FRACTIONAL AREA COVERED BY UNSATURATED DNDRAFT  ***
+  !***  SPFAC IS THE FRACTION OF PRECIPITATION FALLING OUTSIDE ***
+  !***                        OF CLOUD                         ***
+
+  ![TAU: CHARACTERISTIC TIMESCALE USED TO COMPUTE ALPHA & BETA]
+  !***    ALPHA AND BETA ARE PARAMETERS THAT CONTROL THE RATE OF ***
+  !***                 APPROACH TO QUASI-EQUILIBRIUM           ***
+  !***    (THEIR STANDARD VALUES ARE 1.0 AND 0.96, RESPECTIVELY) ***
+  !***           (BETA MUST BE LESS THAN OR EQUAL TO 1)        ***
+
+  !***    DTCRIT IS THE CRITICAL BUOYANCY (K) USED TO ADJUST THE ***
+  !***                 APPROACH TO QUASI-EQUILIBRIUM           ***
+  !***                     IT MUST BE LESS THAN 0              ***
+
+  INTEGER, INTENT(IN) :: nd
+  INTEGER, INTENT(IN) :: k_upper
+  REAL, INTENT(IN) :: delt ! timestep (seconds)
+
+  ! Local variables
+  CHARACTER (LEN = 20) :: modname = 'cv3_param'
+  CHARACTER (LEN = 80) :: abort_message
 
   LOGICAL, SAVE :: first = .TRUE.
-!$OMP THREADPRIVATE(first)
-
-!glb  noff: integer limit for convection (nd-noff)
-! minorig: First level of convection
-
-! -- limit levels for convection:
-
-!jyg<
-!  noff is chosen such that nl = k_upper so that upmost loops end at about 22 km
-
-  noff = min(max(nd-k_upper, 1), (nd+1)/2)
-!!  noff = 1
-!>jyg
+  !$OMP THREADPRIVATE(first)
+
+  !glb  noff: integer limit for convection (nd-noff)
+  ! minorig: First level of convection
+
+  ! -- limit levels for convection:
+
+  !jyg<
+  !  noff is chosen such that nl = k_upper so that upmost loops end at about 22 km
+
+  noff = min(max(nd - k_upper, 1), (nd + 1) / 2)
+  !!  noff = 1
+  !>jyg
   minorig = 1
   nl = nd - noff
@@ -67,76 +65,76 @@
 
   IF (first) THEN
-! -- "microphysical" parameters:
-! IM beg: ajout fis. reglage ep
-! CR+JYG: shedding coefficient (used when iflag_mix_adiab=1)
-! IM lu dans physiq.def via conf_phys.F90     epmax  = 0.993
+    ! -- "microphysical" parameters:
+    ! IM beg: ajout fis. reglage ep
+    ! CR+JYG: shedding coefficient (used when iflag_mix_adiab=1)
+    ! IM lu dans physiq.def via conf_phys.F90     epmax  = 0.993
 
     omtrain = 45.0 ! used also for snow (no disctinction rain/snow)
-! -- misc:
+    ! -- misc:
     dtovsh = -0.2 ! dT for overshoot
-! cc      dttrig = 5.   ! (loose) condition for triggering
+    ! cc      dttrig = 5.   ! (loose) condition for triggering
     dttrig = 10. ! (loose) condition for triggering
     dtcrit = -2.0
-! -- end of convection
-! -- interface cloud parameterization:
+    ! -- end of convection
+    ! -- interface cloud parameterization:
     delta = 0.01 ! cld
-! -- interface with boundary-layer (gust factor): (sb)
+    ! -- interface with boundary-layer (gust factor): (sb)
     betad = 10.0 ! original value (from convect 4.3)
 
-! Var interm pour le getin
-     cv_flag_feed=1
-     CALL getin_p('cv_flag_feed',cv_flag_feed)
-     T_top_max = 1000.
-     CALL getin_p('t_top_max',T_top_max)
-     dpbase=-40.
-     CALL getin_p('dpbase',dpbase)
-     pbcrit=150.0
-     CALL getin_p('pbcrit',pbcrit)
-     ptcrit=500.0
-     CALL getin_p('ptcrit',ptcrit)
-     sigdz=0.01
-     CALL getin_p('sigdz',sigdz)
-     spfac=0.15
-     CALL getin_p('spfac',spfac)
-     tau=8000.
-     CALL getin_p('tau',tau)
-     flag_wb=1
-     CALL getin_p('flag_wb',flag_wb)
-     wbmax=6.
-     CALL getin_p('wbmax',wbmax)
-     ok_convstop=.False.
-     CALL getin_p('ok_convstop ',ok_convstop)
-     tau_stop=15000.
-     CALL getin_p('tau_stop ',tau_stop)
-     ok_intermittent=.False.
-     CALL getin_p('ok_intermittent',ok_intermittent)
-     ok_optim_yield=.False.
-     CALL getin_p('ok_optim_yield',ok_optim_yield)
-     ok_homo_tend=.TRUE.
-     CALL getin_p('ok_homo_tend',ok_homo_tend)
-     ok_entrain=.TRUE.
-     CALL getin_p('ok_entrain',ok_entrain)
-
-     coef_peel=0.25
-     CALL getin_p('coef_peel',coef_peel)
-
-     flag_epKEorig=1
-     CALL getin_p('flag_epKEorig',flag_epKEorig)
-     elcrit=0.0003
-     CALL getin_p('elcrit',elcrit)
-     tlcrit=-55.0
-     CALL getin_p('tlcrit',tlcrit)
-     ejectliq=0.
-     CALL getin_p('ejectliq',ejectliq)
-     ejectice=0.
-     CALL getin_p('ejectice',ejectice)
-     cvflag_prec_eject = .FALSE.
-     CALL getin_p('cvflag_prec_eject',cvflag_prec_eject)
-     qsat_depends_on_qt = .FALSE.
-     CALL getin_p('qsat_depends_on_qt',qsat_depends_on_qt)
-     adiab_ascent_mass_flux_depends_on_ejectliq = .FALSE.
-     CALL getin_p('adiab_ascent_mass_flux_depends_on_ejectliq',adiab_ascent_mass_flux_depends_on_ejectliq)
-     keepbug_ice_frac = .TRUE.
-     CALL getin_p('keepbug_ice_frac', keepbug_ice_frac)
+    ! Var interm pour le getin
+    cv_flag_feed = 1
+    CALL getin_p('cv_flag_feed', cv_flag_feed)
+    T_top_max = 1000.
+    CALL getin_p('t_top_max', T_top_max)
+    dpbase = -40.
+    CALL getin_p('dpbase', dpbase)
+    pbcrit = 150.0
+    CALL getin_p('pbcrit', pbcrit)
+    ptcrit = 500.0
+    CALL getin_p('ptcrit', ptcrit)
+    sigdz = 0.01
+    CALL getin_p('sigdz', sigdz)
+    spfac = 0.15
+    CALL getin_p('spfac', spfac)
+    tau = 8000.
+    CALL getin_p('tau', tau)
+    flag_wb = 1
+    CALL getin_p('flag_wb', flag_wb)
+    wbmax = 6.
+    CALL getin_p('wbmax', wbmax)
+    ok_convstop = .False.
+    CALL getin_p('ok_convstop ', ok_convstop)
+    tau_stop = 15000.
+    CALL getin_p('tau_stop ', tau_stop)
+    ok_intermittent = .False.
+    CALL getin_p('ok_intermittent', ok_intermittent)
+    ok_optim_yield = .False.
+    CALL getin_p('ok_optim_yield', ok_optim_yield)
+    ok_homo_tend = .TRUE.
+    CALL getin_p('ok_homo_tend', ok_homo_tend)
+    ok_entrain = .TRUE.
+    CALL getin_p('ok_entrain', ok_entrain)
+
+    coef_peel = 0.25
+    CALL getin_p('coef_peel', coef_peel)
+
+    flag_epKEorig = 1
+    CALL getin_p('flag_epKEorig', flag_epKEorig)
+    elcrit = 0.0003
+    CALL getin_p('elcrit', elcrit)
+    tlcrit = -55.0
+    CALL getin_p('tlcrit', tlcrit)
+    ejectliq = 0.
+    CALL getin_p('ejectliq', ejectliq)
+    ejectice = 0.
+    CALL getin_p('ejectice', ejectice)
+    cvflag_prec_eject = .FALSE.
+    CALL getin_p('cvflag_prec_eject', cvflag_prec_eject)
+    qsat_depends_on_qt = .FALSE.
+    CALL getin_p('qsat_depends_on_qt', qsat_depends_on_qt)
+    adiab_ascent_mass_flux_depends_on_ejectliq = .FALSE.
+    CALL getin_p('adiab_ascent_mass_flux_depends_on_ejectliq', adiab_ascent_mass_flux_depends_on_ejectliq)
+    keepbug_ice_frac = .TRUE.
+    CALL getin_p('keepbug_ice_frac', keepbug_ice_frac)
 
     WRITE (*, *) 't_top_max=', t_top_max
@@ -160,23 +158,22 @@
     WRITE (*, *) 'ejectliq=', ejectliq
     WRITE (*, *) 'ejectice=', ejectice
-    WRITE (*, *) 'cvflag_prec_eject =', cvflag_prec_eject 
-    WRITE (*, *) 'qsat_depends_on_qt =', qsat_depends_on_qt 
+    WRITE (*, *) 'cvflag_prec_eject =', cvflag_prec_eject
+    WRITE (*, *) 'qsat_depends_on_qt =', qsat_depends_on_qt
     WRITE (*, *) 'adiab_ascent_mass_flux_depends_on_ejectliq =', adiab_ascent_mass_flux_depends_on_ejectliq
-    WRITE (*, *) 'keepbug_ice_frac =', keepbug_ice_frac 
+    WRITE (*, *) 'keepbug_ice_frac =', keepbug_ice_frac
 
     first = .FALSE.
   END IF ! (first)
 
-  beta = 1.0 - delt/tau
+  beta = 1.0 - delt / tau
   alpha1 = 1.5E-3
-!JYG    Correction bug alpha
-  alpha1 = alpha1*1.5
-  alpha = alpha1*delt/tau
-!JYG    Bug
-! cc increase alpha to compensate W decrease:
-! c      alpha  = alpha*1.5
-
-  noconv_stop = max(2.,tau_stop/delt)
-
+  !JYG    Correction bug alpha
+  alpha1 = alpha1 * 1.5
+  alpha = alpha1 * delt / tau
+  !JYG    Bug
+  ! cc increase alpha to compensate W decrease:
+  ! c      alpha  = alpha*1.5
+
+  noconv_stop = max(2., tau_stop / delt)
 
 END SUBROUTINE cv3_param
@@ -184,62 +181,63 @@
 SUBROUTINE cv3_incrcount(len, nd, delt, sig)
   USE lmdz_cvflag
-
-IMPLICIT NONE
-
-! =====================================================================
-!  Increment the counter sig(nd)
-! =====================================================================
-
-  include "cv3param.h"
-
-!inputs:
-  INTEGER, INTENT(IN)                     :: len
-  INTEGER, INTENT(IN)                     :: nd
-  REAL, INTENT(IN)                        :: delt ! timestep (seconds)
-
-!input/output
-  REAL, DIMENSION(len,nd), INTENT(INOUT)  :: sig
-
-!local variables
+  USE lmdz_cvthermo
+  USE lmdz_cv3param
+
+  IMPLICIT NONE
+
+  ! =====================================================================
+  !  Increment the counter sig(nd)
+  ! =====================================================================
+
+  !inputs:
+  INTEGER, INTENT(IN) :: len
+  INTEGER, INTENT(IN) :: nd
+  REAL, INTENT(IN) :: delt ! timestep (seconds)
+
+  !input/output
+  REAL, DIMENSION(len, nd), INTENT(INOUT) :: sig
+
+  !local variables
   INTEGER il
 
-!    print *,'cv3_incrcount : noconv_stop ',noconv_stop
-!    print *,'cv3_incrcount in, sig(1,nd) ',sig(1,nd)
-    IF(ok_convstop) THEN
-      DO il = 1, len
-        sig(il, nd) = sig(il, nd) + 1.
-        sig(il, nd) = min(sig(il,nd), noconv_stop+0.1)
-      END DO
-    ELSE
-      DO il = 1, len
-        sig(il, nd) = sig(il, nd) + 1.
-        sig(il, nd) = min(sig(il,nd), 12.1)
-      END DO
-    ENDIF  ! (ok_convstop)
-!    print *,'cv3_incrcount out, sig(1,nd) ',sig(1,nd)
-
+  !    print *,'cv3_incrcount : noconv_stop ',noconv_stop
+  !    print *,'cv3_incrcount in, sig(1,nd) ',sig(1,nd)
+  IF(ok_convstop) THEN
+    DO il = 1, len
+      sig(il, nd) = sig(il, nd) + 1.
+      sig(il, nd) = min(sig(il, nd), noconv_stop + 0.1)
+    END DO
+  ELSE
+    DO il = 1, len
+      sig(il, nd) = sig(il, nd) + 1.
+      sig(il, nd) = min(sig(il, nd), 12.1)
+    END DO
+  ENDIF  ! (ok_convstop)
+  !    print *,'cv3_incrcount out, sig(1,nd) ',sig(1,nd)
 
 END SUBROUTINE cv3_incrcount
 
-SUBROUTINE cv3_prelim(len, nd, ndp1, t, q, p, ph, &
-                      lv, lf, cpn, tv, gz, h, hm, th)
+SUBROUTINE cv3_prelim(len, nd, ndp1, t, q, p, ph, lv, lf, cpn, tv, gz, h, hm, th)
+  USE lmdz_cv3param
+  USE lmdz_cvthermo
+
   IMPLICIT NONE
 
-! =====================================================================
-! --- CALCULATE ARRAYS OF GEOPOTENTIAL, HEAT CAPACITY & STATIC ENERGY
-! "ori": from convect4.3 (vectorized)
-! "convect3": to be exactly consistent with convect3
-! =====================================================================
-
-! inputs:
+  ! =====================================================================
+  ! --- CALCULATE ARRAYS OF GEOPOTENTIAL, HEAT CAPACITY & STATIC ENERGY
+  ! "ori": from convect4.3 (vectorized)
+  ! "convect3": to be exactly consistent with convect3
+  ! =====================================================================
+
+  ! inputs:
   INTEGER len, nd, ndp1
   REAL t(len, nd), q(len, nd), p(len, nd), ph(len, ndp1)
 
-! outputs:
+  ! outputs:
   REAL lv(len, nd), lf(len, nd), cpn(len, nd), tv(len, nd)
   REAL gz(len, nd), h(len, nd), hm(len, nd)
   REAL th(len, nd)
 
-! local variables:
+  ! local variables:
   INTEGER k, i
   REAL rdcp
@@ -247,111 +245,106 @@
   REAL cpx(len, nd)
 
-  include "cvthermo.h"
-  include "cv3param.h"
-
-
-! ori      do 110 k=1,nlp
-! abderr     do 110 k=1,nl ! convect3
+  ! ori      do 110 k=1,nlp
+  ! abderr     do 110 k=1,nl ! convect3
   DO k = 1, nlp
 
     DO i = 1, len
-! debug          lv(i,k)= lv0-clmcpv*(t(i,k)-t0)
-      lv(i, k) = lv0 - clmcpv*(t(i,k)-273.15)
-!!      lf(i, k) = lf0 - clmci*(t(i,k)-273.15)   ! erreur de signe !!
-      lf(i, k) = lf0 + clmci*(t(i,k)-273.15)
-      cpn(i, k) = cpd*(1.0-q(i,k)) + cpv*q(i, k)
-      cpx(i, k) = cpd*(1.0-q(i,k)) + cl*q(i, k)
-! ori          tv(i,k)=t(i,k)*(1.0+q(i,k)*epsim1)
-      tv(i, k) = t(i, k)*(1.0+q(i,k)/eps-q(i,k))
-      rdcp = (rrd*(1.-q(i,k))+q(i,k)*rrv)/cpn(i, k)
-      th(i, k) = t(i, k)*(1000.0/p(i,k))**rdcp
-    END DO
-  END DO
-
-! gz = phi at the full levels (same as p).
-
-!!  DO i = 1, len                    !jyg
-!!    gz(i, 1) = 0.0                 !jyg
-!!  END DO                           !jyg
-    gz(:,:) = 0.                     !jyg: initialization of the whole array
-! ori      do 140 k=2,nlp
+      ! debug          lv(i,k)= lv0-clmcpv*(t(i,k)-t0)
+      lv(i, k) = lv0 - clmcpv * (t(i, k) - 273.15)
+      !!      lf(i, k) = lf0 - clmci*(t(i,k)-273.15)   ! erreur de signe !!
+      lf(i, k) = lf0 + clmci * (t(i, k) - 273.15)
+      cpn(i, k) = cpd * (1.0 - q(i, k)) + cpv * q(i, k)
+      cpx(i, k) = cpd * (1.0 - q(i, k)) + cl * q(i, k)
+      ! ori          tv(i,k)=t(i,k)*(1.0+q(i,k)*epsim1)
+      tv(i, k) = t(i, k) * (1.0 + q(i, k) / eps - q(i, k))
+      rdcp = (rrd * (1. - q(i, k)) + q(i, k) * rrv) / cpn(i, k)
+      th(i, k) = t(i, k) * (1000.0 / p(i, k))**rdcp
+    END DO
+  END DO
+
+  ! gz = phi at the full levels (same as p).
+
+  !!  DO i = 1, len                    !jyg
+  !!    gz(i, 1) = 0.0                 !jyg
+  !!  END DO                           !jyg
+  gz(:, :) = 0.                     !jyg: initialization of the whole array
+  ! ori      do 140 k=2,nlp
   DO k = 2, nl ! convect3
     DO i = 1, len
-      tvx = t(i, k)*(1.+q(i,k)/eps-q(i,k))         !convect3
-      tvy = t(i, k-1)*(1.+q(i,k-1)/eps-q(i,k-1))   !convect3
-      gz(i, k) = gz(i, k-1) + 0.5*rrd*(tvx+tvy)* & !convect3
-                 (p(i,k-1)-p(i,k))/ph(i, k)        !convect3
-
-! c        print *,' gz(',k,')',gz(i,k),' tvx',tvx,' tvy ',tvy
-
-! ori         gz(i,k)=gz(i,k-1)+hrd*(tv(i,k-1)+tv(i,k))
-! ori    &         *(p(i,k-1)-p(i,k))/ph(i,k)
-    END DO
-  END DO
-
-! h  = phi + cpT (dry static energy).
-! hm = phi + cp(T-Tbase)+Lq
-
-! ori      do 170 k=1,nlp
+      tvx = t(i, k) * (1. + q(i, k) / eps - q(i, k))         !convect3
+      tvy = t(i, k - 1) * (1. + q(i, k - 1) / eps - q(i, k - 1))   !convect3
+      gz(i, k) = gz(i, k - 1) + 0.5 * rrd * (tvx + tvy) * & !convect3
+              (p(i, k - 1) - p(i, k)) / ph(i, k)        !convect3
+
+      ! c        print *,' gz(',k,')',gz(i,k),' tvx',tvx,' tvy ',tvy
+
+      ! ori         gz(i,k)=gz(i,k-1)+hrd*(tv(i,k-1)+tv(i,k))
+      ! ori    &         *(p(i,k-1)-p(i,k))/ph(i,k)
+    END DO
+  END DO
+
+  ! h  = phi + cpT (dry static energy).
+  ! hm = phi + cp(T-Tbase)+Lq
+
+  ! ori      do 170 k=1,nlp
   DO k = 1, nl ! convect3
     DO i = 1, len
-      h(i, k) = gz(i, k) + cpn(i, k)*t(i, k)
-      hm(i, k) = gz(i, k) + cpx(i, k)*(t(i,k)-t(i,1)) + lv(i, k)*q(i, k)
-    END DO
-  END DO
-
+      h(i, k) = gz(i, k) + cpn(i, k) * t(i, k)
+      hm(i, k) = gz(i, k) + cpx(i, k) * (t(i, k) - t(i, 1)) + lv(i, k) * q(i, k)
+    END DO
+  END DO
 
 END SUBROUTINE cv3_prelim
 
 SUBROUTINE cv3_feed(len, nd, ok_conserv_q, &
-                    t, q, u, v, p, ph, h, gz, &
-                    p1feed, p2feed, wght, &
-                    wghti, tnk, thnk, qnk, qsnk, unk, vnk, &
-                    cpnk, hnk, nk, icb, icbmax, iflag, gznk, plcl)
+        t, q, u, v, p, ph, h, gz, &
+        p1feed, p2feed, wght, &
+        wghti, tnk, thnk, qnk, qsnk, unk, vnk, &
+        cpnk, hnk, nk, icb, icbmax, iflag, gznk, plcl)
 
   USE lmdz_phys_transfert_para, ONLY: bcast
   USE add_phys_tend_mod, ONLY: fl_cor_ebil
   USE lmdz_print_control, ONLY: prt_level
+  USE lmdz_cvthermo
+  USE lmdz_cv3param
+
   IMPLICIT NONE
 
-! ================================================================
-! Purpose: CONVECTIVE FEED
-
-! Main differences with cv_feed:
-! - ph added in input
-! - here, nk(i)=minorig
-! - icb defined differently (plcl compared with ph instead of p)
-! - dry static energy as argument instead of moist static energy
-
-! Main differences with convect3:
-! - we do not compute dplcldt and dplcldr of CLIFT anymore
-! - values iflag different (but tests identical)
-! - A,B explicitely defined (!...)
-! ================================================================
-
-  include "cv3param.h"
-  include "cvthermo.h"
-
-!inputs:
-  INTEGER, INTENT (IN)                               :: len, nd
-  LOGICAL, INTENT (IN)                               :: ok_conserv_q
-  REAL, DIMENSION (len, nd), INTENT (IN)             :: t, q, p
-  REAL, DIMENSION (len, nd), INTENT (IN)             :: u, v
-  REAL, DIMENSION (len, nd), INTENT (IN)             :: h, gz
-  REAL, DIMENSION (len, nd+1), INTENT (IN)           :: ph
-  REAL, DIMENSION (len), INTENT (IN)                 :: p1feed
-  REAL, DIMENSION (nd), INTENT (IN)                  :: wght
-!input-output
-  REAL, DIMENSION (len), INTENT (INOUT)              :: p2feed
-!outputs:
-  INTEGER, INTENT (OUT)                              :: icbmax
-  INTEGER, DIMENSION (len), INTENT (OUT)             :: iflag, nk, icb
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: wghti
-  REAL, DIMENSION (len), INTENT (OUT)                :: tnk, thnk, qnk, qsnk
-  REAL, DIMENSION (len), INTENT (OUT)                :: unk, vnk
-  REAL, DIMENSION (len), INTENT (OUT)                :: cpnk, hnk, gznk
-  REAL, DIMENSION (len), INTENT (OUT)                :: plcl
-
-!local variables:
+  ! ================================================================
+  ! Purpose: CONVECTIVE FEED
+
+  ! Main differences with cv_feed:
+  ! - ph added in input
+  ! - here, nk(i)=minorig
+  ! - icb defined differently (plcl compared with ph instead of p)
+  ! - dry static energy as argument instead of moist static energy
+
+  ! Main differences with convect3:
+  ! - we do not compute dplcldt and dplcldr of CLIFT anymore
+  ! - values iflag different (but tests identical)
+  ! - A,B explicitely defined (!...)
+  ! ================================================================
+
+  !inputs:
+  INTEGER, INTENT (IN) :: len, nd
+  LOGICAL, INTENT (IN) :: ok_conserv_q
+  REAL, DIMENSION (len, nd), INTENT (IN) :: t, q, p
+  REAL, DIMENSION (len, nd), INTENT (IN) :: u, v
+  REAL, DIMENSION (len, nd), INTENT (IN) :: h, gz
+  REAL, DIMENSION (len, nd + 1), INTENT (IN) :: ph
+  REAL, DIMENSION (len), INTENT (IN) :: p1feed
+  REAL, DIMENSION (nd), INTENT (IN) :: wght
+  !input-output
+  REAL, DIMENSION (len), INTENT (INOUT) :: p2feed
+  !outputs:
+  INTEGER, INTENT (OUT) :: icbmax
+  INTEGER, DIMENSION (len), INTENT (OUT) :: iflag, nk, icb
+  REAL, DIMENSION (len, nd), INTENT (OUT) :: wghti
+  REAL, DIMENSION (len), INTENT (OUT) :: tnk, thnk, qnk, qsnk
+  REAL, DIMENSION (len), INTENT (OUT) :: unk, vnk
+  REAL, DIMENSION (len), INTENT (OUT) :: cpnk, hnk, gznk
+  REAL, DIMENSION (len), INTENT (OUT) :: plcl
+
+  !local variables:
   INTEGER i, k, iter, niter
   INTEGER ihmin(len)
@@ -363,31 +356,31 @@
   LOGICAL nocond(len)
 
-!jyg20140217<
+  !jyg20140217<
   INTEGER iostat
   LOGICAL, SAVE :: first
   LOGICAL, SAVE :: ok_new_feed
   REAL, SAVE :: dp_lcl_feed
-!$OMP THREADPRIVATE (first,ok_new_feed,dp_lcl_feed)
+  !$OMP THREADPRIVATE (first,ok_new_feed,dp_lcl_feed)
   DATA first/.TRUE./
   DATA dp_lcl_feed/2./
 
   IF (first) THEN
-!$OMP MASTER
+    !$OMP MASTER
     ok_new_feed = ok_conserv_q
-    OPEN (98, FILE='cv3feed_param.data', STATUS='old', FORM='formatted', IOSTAT=iostat)
+    OPEN (98, FILE = 'cv3feed_param.data', STATUS = 'old', FORM = 'formatted', IOSTAT = iostat)
     IF (iostat==0) THEN
-      READ (98, *, END=998) ok_new_feed
-998   CONTINUE
+      READ (98, *, END = 998) ok_new_feed
+      998   CONTINUE
       CLOSE (98)
     END IF
     PRINT *, ' ok_new_feed: ', ok_new_feed
-!$OMP END MASTER
+    !$OMP END MASTER
     CALL bcast(ok_new_feed)
-    first = .FALSE.   
+    first = .FALSE.
   END IF
-!jyg>
-! -------------------------------------------------------------------
-! --- Origin level of ascending parcels for convect3:
-! -------------------------------------------------------------------
+  !jyg>
+  ! -------------------------------------------------------------------
+  ! --- Origin level of ascending parcels for convect3:
+  ! -------------------------------------------------------------------
 
   DO i = 1, len
@@ -396,40 +389,40 @@
   END DO
 
-! -------------------------------------------------------------------
-! --- Adjust feeding layer thickness so that lifting up to the top of
-! --- the feeding layer does not induce condensation (i.e. so that
-! --- plcl < p2feed).
-! --- Method : iterative secant method.
-! -------------------------------------------------------------------
-
-! 1- First bracketing of the solution : ph(nk+1), p2feed
-
-! 1.a- LCL associated with p2feed
+  ! -------------------------------------------------------------------
+  ! --- Adjust feeding layer thickness so that lifting up to the top of
+  ! --- the feeding layer does not induce condensation (i.e. so that
+  ! --- plcl < p2feed).
+  ! --- Method : iterative secant method.
+  ! -------------------------------------------------------------------
+
+  ! 1- First bracketing of the solution : ph(nk+1), p2feed
+
+  ! 1.a- LCL associated with p2feed
   DO i = 1, len
     pup(i) = p2feed(i)
   END DO
-  IF (fl_cor_ebil >=2 ) THEN
+  IF (fl_cor_ebil >=2) THEN
     CALL cv3_estatmix(len, nd, iflag, p1feed, pup, p, ph, &
-                     t, q, u, v, h, gz, wght, &
-                     wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plclup)
+            t, q, u, v, h, gz, wght, &
+            wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plclup)
   ELSE
     CALL cv3_enthalpmix(len, nd, iflag, p1feed, pup, p, ph, &
-                       t, q, u, v, wght, &
-                       wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plclup)
-  ENDIF  ! (fl_cor_ebil >=2 ) 
-! 1.b- LCL associated with ph(nk+1)
+            t, q, u, v, wght, &
+            wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plclup)
+  ENDIF  ! (fl_cor_ebil >=2 )
+  ! 1.b- LCL associated with ph(nk+1)
   DO i = 1, len
-    plo(i) = ph(i, nk(i)+1)
-  END DO
-  IF (fl_cor_ebil >=2 ) THEN
+    plo(i) = ph(i, nk(i) + 1)
+  END DO
+  IF (fl_cor_ebil >=2) THEN
     CALL cv3_estatmix(len, nd, iflag, p1feed, plo, p, ph, &
-                     t, q, u, v, h, gz, wght, &
-                     wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plcllo)
+            t, q, u, v, h, gz, wght, &
+            wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plcllo)
   ELSE
     CALL cv3_enthalpmix(len, nd, iflag, p1feed, plo, p, ph, &
-                       t, q, u, v, wght, &
-                       wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plcllo)
-  ENDIF  ! (fl_cor_ebil >=2 ) 
-! 2- Iterations
+            t, q, u, v, wght, &
+            wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plcllo)
+  ENDIF  ! (fl_cor_ebil >=2 )
+  ! 2- Iterations
   niter = 5
   DO iter = 1, niter
@@ -443,29 +436,29 @@
         pfeed(i) = pup(i)
       ELSE
-!JYG20140217<
+        !JYG20140217<
         IF (ok_new_feed) THEN
-          pfeed(i) = (pup(i)*(plo(i)-plcllo(i)-dp_lcl_feed)+  &
-                      plo(i)*(plclup(i)-pup(i)+dp_lcl_feed))/ &
-                     (plo(i)-plcllo(i)+plclup(i)-pup(i))
+          pfeed(i) = (pup(i) * (plo(i) - plcllo(i) - dp_lcl_feed) + &
+                  plo(i) * (plclup(i) - pup(i) + dp_lcl_feed)) / &
+                  (plo(i) - plcllo(i) + plclup(i) - pup(i))
         ELSE
-          pfeed(i) = (pup(i)*(plo(i)-plcllo(i))+  &
-                      plo(i)*(plclup(i)-pup(i)))/ &
-                     (plo(i)-plcllo(i)+plclup(i)-pup(i))
+          pfeed(i) = (pup(i) * (plo(i) - plcllo(i)) + &
+                  plo(i) * (plclup(i) - pup(i))) / &
+                  (plo(i) - plcllo(i) + plclup(i) - pup(i))
         END IF
-!JYG>
+        !JYG>
       END IF
     END DO
-!jyg20140217<
-! For the last iteration, make sure that the top of the feeding layer
-! and LCL are not in the same layer:
+    !jyg20140217<
+    ! For the last iteration, make sure that the top of the feeding layer
+    ! and LCL are not in the same layer:
     IF (ok_new_feed) THEN
       IF (iter==niter) THEN
-        DO i = 1,len                         !jyg
-          pfeedmin(i) = ph(i,minorig+1)      !jyg
+        DO i = 1, len                         !jyg
+          pfeedmin(i) = ph(i, minorig + 1)      !jyg
         ENDDO                                !jyg
-        DO k = minorig+1, nl                 !jyg
-!!        DO k = minorig, nl                 !jyg
+        DO k = minorig + 1, nl                 !jyg
+          !!        DO k = minorig, nl                 !jyg
           DO i = 1, len
-            IF (ph(i,k)>=plclfeed(i)) pfeedmin(i) = ph(i, k)
+            IF (ph(i, k)>=plclfeed(i)) pfeedmin(i) = ph(i, k)
           END DO
         END DO
@@ -475,37 +468,37 @@
       END IF
     END IF
-!jyg>
-
-    IF (fl_cor_ebil >=2 ) THEN
+    !jyg>
+
+    IF (fl_cor_ebil >=2) THEN
       CALL cv3_estatmix(len, nd, iflag, p1feed, pfeed, p, ph, &
-                       t, q, u, v, h, gz, wght, &
-                       wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plclfeed)
+              t, q, u, v, h, gz, wght, &
+              wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plclfeed)
     ELSE
       CALL cv3_enthalpmix(len, nd, iflag, p1feed, pfeed, p, ph, &
-                         t, q, u, v, wght, &
-                         wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plclfeed)
-    ENDIF  ! (fl_cor_ebil >=2 ) 
-!jyg20140217<
+              t, q, u, v, wght, &
+              wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plclfeed)
+    ENDIF  ! (fl_cor_ebil >=2 )
+    !jyg20140217<
     IF (ok_new_feed) THEN
       DO i = 1, len
-        posit(i) = (sign(1.,plclfeed(i)-pfeed(i)+dp_lcl_feed)+1.)*0.5
-        IF (plclfeed(i)-pfeed(i)+dp_lcl_feed==0.) posit(i) = 1.
+        posit(i) = (sign(1., plclfeed(i) - pfeed(i) + dp_lcl_feed) + 1.) * 0.5
+        IF (plclfeed(i) - pfeed(i) + dp_lcl_feed==0.) posit(i) = 1.
       END DO
     ELSE
       DO i = 1, len
-        posit(i) = (sign(1.,plclfeed(i)-pfeed(i))+1.)*0.5
+        posit(i) = (sign(1., plclfeed(i) - pfeed(i)) + 1.) * 0.5
         IF (plclfeed(i)==pfeed(i)) posit(i) = 1.
       END DO
     END IF
-!jyg>
+    !jyg>
     DO i = 1, len
-! - posit = 1 when lcl is below top of feeding layer (plclfeed>pfeed)
-! -               => pup=pfeed
-! - posit = 0 when lcl is above top of feeding layer (plclfeed<pfeed)
-! -               => plo=pfeed
-      pup(i) = posit(i)*pfeed(i) + (1.-posit(i))*pup(i)
-      plo(i) = (1.-posit(i))*pfeed(i) + posit(i)*plo(i)
-      plclup(i) = posit(i)*plclfeed(i) + (1.-posit(i))*plclup(i)
-      plcllo(i) = (1.-posit(i))*plclfeed(i) + posit(i)*plcllo(i)
+      ! - posit = 1 when lcl is below top of feeding layer (plclfeed>pfeed)
+      ! -               => pup=pfeed
+      ! - posit = 0 when lcl is above top of feeding layer (plclfeed<pfeed)
+      ! -               => plo=pfeed
+      pup(i) = posit(i) * pfeed(i) + (1. - posit(i)) * pup(i)
+      plo(i) = (1. - posit(i)) * pfeed(i) + posit(i) * plo(i)
+      plclup(i) = posit(i) * plclfeed(i) + (1. - posit(i)) * plclup(i)
+      plcllo(i) = (1. - posit(i)) * plclfeed(i) + posit(i) * plcllo(i)
     END DO
   END DO !  iter
